﻿using System;

namespace David.Academy.ProgrammingInCSharp.Classes
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Деклариране и инстанциране на обект от клас Teacher
			Teacher mihova = new Teacher();
			// Попълване на полетата на обекта
			mihova.Name = "Петя Михова";
			mihova.Age = 65;
			// Проверка за премината пенсионна възраст чрез сравнение с константно поле
			mihova.IsRetired = (mihova.Age > Teacher.RetirementAge);

			// Дейклариране на променлива от клас Subject
			Subject bel;
			// Опити за достъпване на поле на неинициализирана променлива - грешка при компилация
			//Console.WriteLine(bel.Name);
			//bel.Grade = 3;

			// Инстациране на обект от клас Subject с инициализация на полетата
			bel = new Subject()
			{
				Grade = 8,
				IsElective = false, // unfortunately
				Name = "Български език и литература",
			};

			// Изпечатване на низово представяне на обекта
			Console.WriteLine(bel);

			// Изпечатване на информация за учителя
			WriteTeacherInfo(mihova);

			// Деклариране на променлива от клас Author
			Author author;
			// Инстанциране на обект от клас Author
			author = new Author();
			// Попълване на полетата на обекта
			author.Name = "Dan Brown";
			author.Nationality = "American";
			author.YearBorn = 1969;

			// Деклариране и инстанциране на обект от клас Book с инициализация на полетата
			Book myFavouriteBook = new Book()
			{
				Title = "Inferno",
				Author = author,
				PageCount = 450,
			};
			// Проверка за дълга книга чрез ставнение с константно поле
			myFavouriteBook.IsLong = (myFavouriteBook.PageCount > Book.PageThreshold);

			// Изпечатване на информация за книгата
			Console.WriteLine("My favourite book is {0} by {1}, who is {2} and was born in {3}. The book is {4} pages long, which is {5}quite long.",
				myFavouriteBook.Title,
				myFavouriteBook.Author.Name,
				myFavouriteBook.Author.Nationality,
				myFavouriteBook.Author.YearBorn,
				myFavouriteBook.PageCount,
				(myFavouriteBook.IsLong ? "" : "not "));

			// Деклариране и инстанциране на обект от клас UserInfo
			UserInfo userInfo = new UserInfo();

			// Изпечатване на потребителската информация съхранена в полета само за четене
			Console.WriteLine(@"{0}\{1} logged into {2}. Info obtained on {3}.",
				userInfo.DomainName, userInfo.UserName, userInfo.MachineName, userInfo.ObtainedOn);

			// Опит за присвояване на стойност на поле само за четене - грешка при компилация
			//userInfo.UserName = "Александър Далемски";

			Console.ReadLine();
		}

		/// <summary>
		/// Функция за изпечатване на информация за учител
		/// </summary>
		/// <param name="teacher">Обект, представляващ учителя</param>
		private static void WriteTeacherInfo(Teacher teacher)
		{
			// Изпечатване на стойностите на полетата на обекта от клас Teacher
			Console.WriteLine("{0}, {1}, Пенсиониран(а): {2}", teacher.Name, teacher.Age, teacher.IsRetired);
		}
	}
}
