﻿using System;

namespace David.Academy.ProgrammingInCSharp.Encapsulation
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Създаване на точка A чрез указване на декартови координати
			Point a = new Point(1, 1);
			// Извеждане на декартовите координати на точка A
			PrintCartesian("A", a);
			// Извеждане на полярните координати на точка A
			PrintPolar("A", a);

			// Създаване на точка B чрез указване на полярни координати
			Point b = new Point(Math.PI / 3, 33);
			// Извеждане на декартовите координати на точка B
			PrintCartesian("B", b);
			// Извеждане на полярните координати на точка B
			PrintPolar("B", b);

			// Опит за достъпване на частно поле на точка - грешка при компилация
			//a._x = 3;

			// Създаване на кръг и изпечатване на лицето му
			Circle circle = new Circle(Math.Sqrt(33));
			Console.WriteLine("Circle area = {0}", circle.GetArea());

			// Промяна на радиуса на кръга и изпечатване на лицето му след промяната
			circle.SetRadius(Math.Sqrt(22));
			Console.WriteLine("New circle area = {0}", circle.GetArea());

			// Опит за създаване на екземпляр на класа Shape2D - грешка при компилация,
			// тъй като конструкторър е защитен - достъпен единствено в наследените класове
			//Shape2D shape = new Shape2D(40);

			Console.ReadLine();
		}

		/// <summary>
		/// Изпечатва декартовите координати на точка с указано име
		/// </summary>
		/// <param name="name">Име на точката</param>
		/// <param name="point">Точка</param>
		public static void PrintCartesian(string name, Point point)
		{
			Console.WriteLine("cart({0}) = ({1}, {2})", name, point.GetX(), point.GetY());
		}

		/// <summary>
		/// Изпечатва полярните координати на точка с указано име
		/// </summary>
		/// <param name="name">Име на точката</param>
		/// <param name="point">Точка</param>
		public static void PrintPolar(string name, Point point)
		{
			Console.WriteLine("polar({0}) = ({1}, {2})", name, point.GetAngle(), point.GetRadius());
		}
	}
}
