﻿using System;

namespace David.Academy.ProgrammingInCSharp.Indexers
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Създаване на екземпляр на класа Library
			Library myLibrary = new Library(10);
			// Попълване на библиотеката с няколко книги
			myLibrary.AddBook(new Book("Inferno", "Dan Brown"));
			myLibrary.AddBook(new Book("The Wind through the Keyhole", "Stephen King"));
			myLibrary.AddBook(new Book("The Green Mile", "Stephen King"));
			myLibrary.AddBook(new Book("Винету", "Карл Май"));
			myLibrary.AddBook(new Book("Ад", "Данте Алигиери"));
			myLibrary.AddBook(new Book("Приказки", "Братя Грим"));

			// Изпечатване на книгите в библиотеката на конзолата, използвайки индексатора им
			// за достъпване на книга по номера ѝ в колекцията
			for (int i = 1; i <= myLibrary.BookCount; i++)
			{
				Book book = myLibrary[i];
				Console.WriteLine("Book #{0}: {1} by {2}", i, book.Title, book.Author);
			}

			// Откриване на книга чрез индексатора за достъпване на книга по заглавието ѝ
			Book favouriteBook = myLibrary["Inferno"];
			Console.WriteLine("My favourite book is {0} by {1}.",
				favouriteBook.Title,
				favouriteBook.Author);

			Console.ReadLine();
		}
	}
}
