﻿namespace David.Academy.ProgrammingInCSharp.Properties
{
	/// <summary>
	/// Клас за контролна работа по учебен предмет
	/// </summary>
	class Test
	{
		// Частно поле за съхраняване на името на предмета, по който е контролната работа
		private string _subject;

		/// <summary>
		/// Свойство за име на предмет, по който е контролната работа
		/// </summary>
		public string Subject
		{
			// Блок за прочитане името на предмета
			get
			{
				//Console.WriteLine("The test's subject was read.");
				return _subject;
			}
			// Блок за промяна името на предмета
			set
			{
				//Console.WriteLine("The test's subject was assigned the value {0}.", value);
				switch (value)
				{
					case "Maths":
					case "Physics":
						_subject = value;
						IsInteresting = true;
						break;
					case "English":
					case "BEL":
						_subject = value;
						IsInteresting = false;
						break;
				}
			}
		}

		/// <summary>
		/// Автоматично генерирано свойство, указващо дали предметът, по който е контролната работа, е "интересен";
		/// Достъпът за четене е публичен, а достъпът за запис - частен
		/// </summary>
		public bool IsInteresting { get; private set; }

		/// <summary>
		/// Конструктор на контролната работа с име на предмет
		/// </summary>
		/// <param name="subject">Име на предмет, по който е контролната работа</param>
		public Test(string subject)
		{
			Subject = subject;
		}
	}
}
