﻿using System;

namespace David.Academy.ProgrammingInCSharp.Zoo
{
	// наследяването на системния клас "object" се подразбира
	class Animal : object
	{
		public string Barcode { get; private set; }

		public string Name { get; set; }

		public DateTime? BirthDate { get; set; }

		public Animal()
		{
		}

		public Animal(string barcode)
			: this()
		{
			Barcode = barcode;
		}

		public Animal(string barcode, DateTime birthDate)
			: this(barcode)
		{
			BirthDate = birthDate;
		}

		public void Eat(Plant plant)
		{
			Console.WriteLine("Ммм... салата от {0}!", plant.Name);
		}

		public void Eat(Animal animal)
		{
			Console.WriteLine("Омномном... {0}!", animal.Barcode);
		}

		public virtual void MakeSound()
		{
		}

		public override string ToString()
		{
			return string.Format("Животно от тип {0} с баркод {1} и име {2}",
				base.ToString(), Barcode, Name);
		}
	}
}
