﻿using System;

namespace David.Academy.ProgrammingInCSharp.Zoo
{
	class Zoo
	{
		private readonly string _name;
		private Animal[] _animals;

		public string Name
		{
			get { return _name; }
		}

		public int AnimalCount
		{
			get { return _animals.Length; }
		}

		public Animal this[int index]
		{
			get { return _animals[index]; }
		}

		public Animal this[string barcode]
		{
			get
			{
				foreach (Animal animal in _animals)
				{
					if (animal.Barcode == barcode)
						return animal;
				}

				return null;
			}
		}

		public Zoo(string name)
		{
			_name = name;
			_animals = new Animal[] { };
		}

		public void AddAnimal(Animal animal)
		{
			// създаваме нов масив с място за още едно животно
			Animal[] animals = new Animal[_animals.Length + 1];
			// копираме животните от стария масив в новия
			Array.Copy(_animals, animals, _animals.Length);
			// добавяме новото животно
			animals[animals.Length - 1] = animal;
			// подменяме масива
			_animals = animals;
		}
	}
}
