﻿using System;

namespace David.Academy.ProgrammingInCSharp.Abstraction
{
	/// <summary>
	/// Клас за квадрат. Наследява абстрактния клас Shape2D и предефинира абстрактните му членове
	/// </summary>
	class Square : Shape2D
	{
		// Частно поле за съхраняване дължината на страната на квадрата
		private double _side;

		/// <summary>
		/// Предефиниране на абстрактното свойство за периметър на равнинната фигура
		/// </summary>
		public override double Perimeter
		{
			get { return _side * 4; }
		}

		/// <summary>
		/// Предефиниране на абстрактното свойство за лице на равнинната фигура
		/// </summary>
		public override double Area
		{
			get { return Math.Pow(_side, 2); }
		}

		/// <summary>
		/// Предефиниране на абстрактния метод за въвеждане на характеристиките на равнинната фигура от конзолата
		/// </summary>
		public override void InputFromConsole()
		{
			Console.Write("Side = ");
			_side = double.Parse(Console.ReadLine());
		}

		/// <summary>
		/// Предефиниране на виртуалния метод за извеждане на характеристиките на равнинната фигура на конзолата
		/// </summary>
		public override void PrintToConsole()
		{
			Console.WriteLine("Side = {0}", _side);
			// Преизползване на родителския метод
			base.PrintToConsole();
		}
	}
}
