﻿using System;

namespace David.Academy.ProgrammingInCSharp.Enumerations
{
	/// <summary>
	/// Клас, който подлежи на изрично освобождаване на ресурси. Имплементира интерфейса IDisposable
	/// </summary>
	class DisposableObject : IDisposable
	{
		/// <summary>
		/// Освобождава заетите от обекта ресурси. Трабва да се извика от програмиста, когато всички
		/// дейности с обекта са приключили
		/// </summary>
		public void Dispose()
		{
			// В случая няма ресурси за освобождаване, но се изпечатва съобщение на конзолата
			// за доказателство, че методът е бил извикан
			Console.WriteLine("DisposableObject::Dispose() was executed.");
		}
	}
}
