﻿using System;
using System.IO;

namespace David.Academy.ProgrammingInCSharp.Enumerations
{
	/// <summary>
	/// Клас за песен
	/// </summary>
	class Song
	{
		// Частни полета за съхраняване на заглавието и изпълнителя на песента
		private readonly string _title;
		private readonly string _artist;

		/// <summary>
		/// Конструктор на песента с параметри заглавие и изпълнител
		/// </summary>
		/// <param name="title"></param>
		/// <param name="artist"></param>
		public Song(string title, string artist)
		{
			_title = title;
			_artist = artist;
		}

		/// <summary>
		/// Изпечатва характеристиките на песента на конзолата
		/// </summary>
		public void PrintToConsole()
		{
			Console.WriteLine("\"{0}\" by {1}", _title, _artist);
		}

		/// <summary>
		/// Изпечатва харакетристиките на песента в подадения TextWriter обект
		/// </summary>
		/// <param name="writer">Обект, в който трябва да бъдат изпечатани характеристиките
		/// на песента</param>
		public void PrintToWriter(TextWriter writer)
		{
			writer.WriteLine("\"{0}\" by {1}", _title, _artist);
		}
	}
}
