﻿using System;
using System.Collections.Generic;

namespace David.Academy.ProgrammingInCSharp.Generics
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Създаване на екземпляр на класа BinaryTreeNode<int>
			// Класа BinaryTreeNode<int> е шаблонен екземпляр на шаблонния клас BinaryTreeNode<T>,
			// в който типовият параметър T е заменен с действителния тип int
			BinaryTreeNode<int> root = new BinaryTreeNode<int>(11);
			// Добавяне на възли към нареденото двоично дърво от цели числа
			root.AddNode(5);
			root.AddNode(10);
			root.AddNode(17);
			root.AddNode(0);

			// Опит за добавяне на възел с данни от несъвместим с дървото тип;
			// Предизвиква грешка при компилация
			//root.AddNode("dog");

			// Опит за създаване на шаблонна инстанция на шаблонния клас BinaryTreeNode<T>
			// с действителен тип, който не имплементира интерфейса IComparable;
			// Предизвиква грешка при компилация, тъй като действителният тип Program не
			// удовлетворява наложеното ограничение за типовия параметър T
			//BinaryTreeNode<Program> root;

			// Използване на помощния метод BinaryTreeHelper.ConvertTreeToList<T>(BinaryTreeNode<T>),
			// за да бъде преобразувано нареденото двоично дърво от цели числа в списък то цели числа
			// със същите елементи, като се запазва наредбата им;
			// При извикването на метода, типовият параметър T е заместен с действителния тип int
			List<int> list = BinaryTreeHelper.ConvertTreeToList<int>(root);
			// Възможно е също и действителният тип да не бъде указан явно, тъй като компилаторът може
			// да го разпознае по типа на аргумента, подаден на метода:
			//List<int> list2 = BinaryTreeHelper.ConvertTreeToList(root);

			// Опит за извикване на метода BinaryTreeHelper.ConvertTreeToList<T>(BinaryTreeNode<T>)
			// с действителен тип, несъвместим с подадения на метода аргумент;
			// Предизвиква грешка при компилация
			//List<string> list3 = BinaryTreeHelper.ConvertTreeToList<string>(root);

			// Извеждане на сортирания списък от числа
			foreach (int number in list)
			{
				Console.WriteLine(number);
			}

			Console.ReadLine();
		}
	}
}
