﻿using System;

namespace David.Academy.ProgrammingInCSharp.Interfaces
{
	/// <summary>
	/// Клас за аларма. Имплементира интерфейсите ISoundMaker (явно) и IPrintable (неявно)
	/// </summary>
	class Alarm : ISoundMaker, IPrintable
	{
		// Частно поле само за четене за съхраняване на датата и часа на активиране на алармата
		private readonly DateTime _alarmDate;

		/// <summary>
		/// Конструктор на алармата с параметър дата и час на активиране
		/// </summary>
		/// <param name="alarmDate">Дата и час на активиране на алармата</param>
		public Alarm(DateTime alarmDate)
		{
			_alarmDate = alarmDate;
		}

		/// <summary>
		/// Издава звук, специфичен за алармата
		/// </summary>
		void ISoundMaker.MakeSound()
		{
			Console.WriteLine("Цирик-цирик");
		}

		/// <summary>
		/// Изпечатва характеристиките на алармата на конзолата
		/// </summary>
		public void PrintToConsole()
		{
			Console.WriteLine("Alarm set for: {0}", _alarmDate);
		}
	}
}
