﻿using System;

namespace David.Academy.ProgrammingInCSharp.Interfaces
{
	/// <summary>
	/// Клас за песен. Имплементира интерфейса IPrintable (неявно)
	/// </summary>
	class Song : IPrintable
	{
		// Частни полета само за четене за съхраняване заглавието и изпълнителя на песента
		private readonly string _title;
		private readonly string _artist;

		/// <summary>
		/// Конструктор на песента с параметри заглавие и изпълнител
		/// </summary>
		/// <param name="title">Заглавие на песента</param>
		/// <param name="artist">Изпълнител на песента</param>
		public Song(string title, string artist)
		{
			_title = title;
			_artist = artist;
		}

		/// <summary>
		/// Изпечатва характеристиките на песента на конзолата
		/// </summary>
		public void PrintToConsole()
		{
			Console.WriteLine("\"{0}\" by {1}", _title, _artist);
		}
	}
}
