﻿using System;
using System.ComponentModel;

namespace David.Academy.ProgrammingInCSharp.Attributes
{
	[Serializable]
	[Description("Describes a book entry")]
	[HtmlDescription("Describes a <strong>book entry</strong>")]
	class BookEntry
	{
		[NonSerialized]
		private int _id;

		[HtmlDescription("Book <strong>ISBN</strong>")]
		public string Isbn { get; private set; }

		[HtmlDescription("Book <strong>name</strong>")]
		public string Name { get; private set; }

		[Obsolete("You should no longer use this property. To be removed in future versions.", false)]
		public DateTime? IssueDate { get; set; }

		//[HtmlDescription("Book <strong>ISBN</strong>")]
		public BookEntry(
			[Description("Book ISBN")] string isbn,
			[Description("Book name")] string name)
		{
			Isbn = isbn;
			Name = name;
		}

		[Obsolete("You should no longer use this method. Use constructor instead.", true)]
		public static BookEntry CreateEntry(string isbn, string name)
		{
			BookEntry entry = new BookEntry(isbn, name);

			return entry;
		}
	}
}
