﻿using System;

namespace David.Academy.ProgrammingInCSharp.Exceptions
{
	class BookEntry
	{
		public string Isbn { get; private set; }

		public string Name { get; private set; }

		public DateTime? IssueDate { get; set; }

		public BookEntry(string isbn, string name)
		{
			if (string.IsNullOrWhiteSpace(isbn))
				throw new BookDatabaseException(BookDatabaseStatus.ArgumentError, "Missing book ISBN.");

			if (string.IsNullOrWhiteSpace(name))
				throw new BookDatabaseException(BookDatabaseStatus.ArgumentError, "Missing book name.");

			Isbn = isbn;
			Name = name;
		}

		public static BookEntry CreateEntry(string isbn, string name, out BookDatabaseStatus status)
		{
			if (string.IsNullOrWhiteSpace(isbn))
			{
				status = BookDatabaseStatus.ArgumentError;
				return null;
			}

			if (string.IsNullOrWhiteSpace(name))
			{
				status = BookDatabaseStatus.ArgumentError;
				return null;
			}

			BookEntry entry = new BookEntry(isbn, name);

			status = BookDatabaseStatus.Ok;

			return entry;
		}
	}
}
