﻿using System;

namespace David.Academy.ProgrammingInCSharp.Lambdas
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Ламбда функция с израз с един параметър от тип double,
			// която умножава аргумента си по 3 и го връща
			Func<double, double> multiplyBy3 =
			    (double x) => x * 3;
			// Същата ламбда функция без явно указване на типа на параметъра
			multiplyBy3 =
			    (x) => x * 3;
			// Същата ламбда функция без заграждане на единствения параметър в скоби
			multiplyBy3 =
				x => x * 3;

			// Ламбда функция със съждения с един параметър от тип double,
			// която умножава аргумента си по 3 и го връща
			//Func<double, double> multiplyBy3 =
			//	x =>
			//	{
			//		return x * 3;
			//	};

			// Въвеждане на дробно число от клавиатурата
			Console.Write("А = ");
			double а = double.Parse(Console.ReadLine());
			// Прилагане на ламбда фунцкията и извеждане на резултата
			Console.WriteLine("Result = {0}", multiplyBy3(а));

			// Въвеждане на цяло число от клавиатурата
			Console.Write("N = ");
			int n = int.Parse(Console.ReadLine());

			// Ламбда функция с израз с един параметър от тип int,
			// която умножава аргумента си по стойността на локалната променлива n и го връща
			Func<int, int> multiply =
				x => x * n;

			// Ако стойността на локалната променлива бъде променена след създаването
			// на ламбда функцията, това се отразява на действието ѝ
			n = 3;

			// Извеждане на първите 10 кратни на n числа на конзолата
			for (int i = 1; i <= 10; i++)
			{
				Console.WriteLine(multiply(i));
			}

			// Създаване на противник
			Enemy wolf = new Enemy(10);
			// Деклариране на променлива от типа на събитието EnemyDied на противника
			Enemy.EnemyDiedHandler enemyDiedHandler = null;
			// Създаване на обработчик на събитието EnemyDied чрез ламбда функция със съждения
			enemyDiedHandler =
				e =>
				{
					Console.WriteLine("The enemy has died! You loot a shattered claw.");
					e.EnemyDied -= enemyDiedHandler;
				};
			// Закачане на създадения обработчик за събитието EnemyDied на противника
			wolf.EnemyDied += enemyDiedHandler;
			// Правене на несмъртоносни щети на противника
			wolf.Damage(8);
			// Правене на смъртоносни щети на противника - събитието за смърт ще бъде предизвикано
			wolf.Damage(3);

			// Създаване на колекция от книги
			BookCollection collection = new BookCollection(2);
			// Деклариране на променлива от типа на събитието CollectionFilled на колекцията
			BookCollection.CollectionFilledHandler collectionFilledHandler = null;
			// Създаване на обработчик на събитието CollectionFilled чрез ламбда функция със съждения
			collectionFilledHandler =
				c =>
				{
					Console.WriteLine(
						"The collection contains {0} books and is full.",
						collection.Count);
					c.CollectionFilled -= collectionFilledHandler;
				};
			// Закачане на създадения обработчик за събитието CollectionFilled на колекцията
			collection.CollectionFilled += collectionFilledHandler;
			// Добавяне на първа книга в колекцията
			collection.AddBook(
				new Book
				{
					Title = "Hobbit",
					Author = "J. R. R. Tolkien",
				});
			// Добавяне на втора книга в колекцията - събитието за запълване на колекцията ще бъде предизвикано
			collection.AddBook(
				new Book
				{
					Title = "The Fellowship of the Ring",
					Author = "J. R. R. Tolkien",
				});

			Console.ReadLine();
		}
	}
}
